/***************************************************************************
 *   Copyright (C) 2004 by Walter Roth                                     *
 *   walter@amd2600-roth                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "guisqlqueryresult.h"
#include <qmessagebox.h>
#include "globals.h"
#include <qlistview.h>
#include <qvariant.h>
#include <qvaluelist.h>
#include <qdatatable.h>
#include <qsqlcursor.h>
#include <qsqlselectcursor.h> 


GuiSqlQueryResult::GuiSqlQueryResult(QWidget *parent, const char *name)
 : GuiSqlQueryResultBase(parent, name)
{

}


GuiSqlQueryResult::~GuiSqlQueryResult()
{

}


void GuiSqlQueryResult::slotExport(){
  emit exportdata(dataTableResult);
}

void GuiSqlQueryResult::slotBack(){
 emit goback();
}

bool GuiSqlQueryResult::executeQuery(QString querytext){
    
    
    if (USE_MYSQL_FEATURES){

         // Create a Databank Connection
	 
	 QSqlDatabase* transactionDB = QSqlDatabase::addDatabase( "QMYSQL3" );

       if( transactionDB ) {
      		transactionDB->setHostName( MYSQL_HOST );
       		transactionDB->setDatabaseName( MYSQL_DATABASE );
       		transactionDB->setUserName( MYSQL_USER );
       		transactionDB->setPassword( MYSQL_PASSWORD );

       if( transactionDB->open() ) {
       
       
       qDebug("Creating SelectCursor");
       QSqlSelectCursor* cursor = new QSqlSelectCursor(querytext,transactionDB);
       //cursor.exec(querytext);
       
       
      // if (! cursor->isNull()){
       qDebug("Setting SqlCursor for Datatable");
       	   dataTableResult->setSqlCursor(cursor, true, false);
	
       qDebug("Refreshing Datatable");
       dataTableResult->refresh(QDataTable::RefreshAll);
      // }
       
       
       
       }
        else
           qDebug( "Could not open database" );

  	} else	
             qDebug( "Could not activate database driver" );
}

       
  /**  if (!_database->open() ){
	QString error = _database->lastError().text();
        QMessageBox::information(this, tr("Connection Error"), tr("Could not connect to database. \n\n") + error);
    } */
// 	while( query->next() ) {
// 
// 		new QListViewItem( listViewResult,
// 
// 				query->value( 0 ).toString(),
// 				query->value( 1 ).toString(),
// 				query->value( 2 ).toString(),
// 				query->value( 3 ).toString() );
// 
// 	}
// 
//            listViewResult->addColumn( "Datum" );
//            listViewResult->addColumn( "Betrag" );
//            listViewResult->addColumn( "Empfänger" );
//            listViewResult->addColumn( "Text" );
//            listViewResult->show();
// 


// 	while (query->next()) {
// 	
// 	int position = 0;
// 	QVariant value;
// //	QListViewItem item = new QListViewItem(listViewQueryResult,"","","","","","","","");
// 	
// 	do {
// 	
// 	
// 	value = query->value(position);
// 	
// 	// check if value exists
// 	if (value.isValid()){
// 		item.setText(position + 1, value.toString());
// 	}
// 	
// 	position++;
// 	
// 	
// 	} while (value.isValid());
// 	
// 	
// 	  
// 	
// 	}

return false;
}
